/* Transformacoes 3D (translacao, rotacao), 3D para 2D (projecao), 2D
(translacao).

SISTEMAS DE COORDENADAS:

 Sistema 2D (tela = viewport)
 (0,0) - posicao da origem na tela
   *----->X
   |
  Y|
   |
   V

 Sistema 3D (espaco virtual):
Como para desenharmos um objeto aparecendo na tela eh necessario translada-lo
ateh uma posicao dentro da area de visao da tela podemos dizer que a posicao
da tela eh fixa e o espaco tem coordenadas relativas a essa origem. Posicao
da tela eh (0,0,0), fica exatamente na origem da tela. A posicao de um objeto
                     depende de onde o objeto 3D for projetado e transladado.
   +-----+X          Se um objeto que foi
   | \ / |           definido na origem (centro na origem), for projetado e o
  Y|  *Z |*=(0,0,0)  objeto 2D resultante for transladado para
   | / \ |  (origem) X = 160 e Y = 100 entao a origem do sistema de
   +-----+           coordenadas do espaco no plano da tela serah (160, 100).
      A              Falamos: o objeto foi projetado para o meio da tela
		|  				do modo grafico default (360x200).
      |              O ponto de fuga eh o ponto para onde o objeto 3D foi
    exemplo          projetado no plano da tela.

intervalo para X: limites de INT16 (se 16 bits: -32768 a 32767)
intervalo para Y: limites de INT16 (se 16 bits: -32768 a 32767)
intervalo para Z: MINZ ateh MAXZ (com projecoes calculadas).

PROJECAO PERPECTIVA (USA Z):

O centro de visao (superficie da tela) no espaco virtual eh uma area quadrada
de 2 unidades para cima, baixo, direita e esquerda em (0,0,0). Se um objeto
de dimensoes de 2 unidades, na origem do espaco virtual, for projetado para o
centro da tela ele ficara com os seus extremos projetados em MINX, MAXX e
MINY, MAXY. Ou seja, um objeto de qualquer tamanho que estiver encostado no
centro de visao nao terah os seus limites visiveis (exceto se for do tamanho
do centro de visao, limites serao visiveis).

Se Z positivo:
quanto maior o Z mais proximo do ponto de fuga, mais para a frente, menor e
mais distante o objeto do ponto de visao central (observador).
Se Z negativo:
Quanto menor o Z mais distante do ponto de fuga, mais para a tras, fora da
tela se o centro de fuga eh o centro da tela, maior o objeto.
Se Z = 0:
Objeto encostado no centro de visao

Formula para projecoes de Z em Y (como Z influi na coordenada Y do objeto a
ser projetado, que valor Z assume em Y ao ser projetado se Y em 3D era 0):
	se Z = 0: f(Z) = RESY2, RESY2 eh metade da resolucao vertical
	se Z > 0: f(Z) = RESY2 / CONSTANTE, const. depende do angulo de visao em Y
   se Z < 0: f(Z) = 1 / RESY2 / CONSTANTE, cria efeito de aumento do objeto

Formula para projecoes de Z em X:
	se Z = 0: f(Z) = RESX2, RESX2 eh metade da resolucao horizontal
	se Z > 0: f(Z) = RESX2 / CONSTANTE, const. depende do angulo de visao em X
   se Z < 0: f(Z) = 1 / RESX2 / CONSTANTE

   A CONSTANTE eh um valor que depende do angulo de visao (indica
	quantas unidades X e Y devem ser alteradas a cada unidade Z alterada).
   Deve ser 1 em Z = 0.
   Obs.: se as coordenadas usadas tiverem dimensoes na ordem de dezenas eh
   bom usar CONSTANTE +-= 1. Se as coordenadas forem na ordem de unidade eh
	bom usar 0.01. Assim bons efeitos de perspectiva (bem granulares) serao
   obtidos.

   Calculo do angulo de visao em Y (tendo quanto Y varia):
                                         I      P
                       ------------------+--------------------- Y
                                         |             /
                                         |Z           /
 Exemplo:                                |           /
 |OI| = 1 (se varia 1 em Z)              |          /
 |IP| = 1 (quanto Y varia, incremento    |A'       /
           de CONSTANTE = |IP|)          |--------/
 |OP| = sqrt ( |OI|^2 + |IP|^2 ) =       |       /
      = sqrt ( 2 )                       *-------  ( <- 1/2 lado do centro de
 A' = ? = angulo entre OI e OP           O            visao: 1 unidade)
                                      (observador)
 A' = arco_seno ( |IP| / |OP| ) = arco_seno ( 1 / sqrt ( 2 ) ) = 45 graus
 A  = angulo de visao em Y = 2 * A' = 90 graus, graus dados de 0 a 359

 	Calculo do angulo de visao em X eh semelhante.

Os valores obtidos pelas formulas f(Z) sao multiplicados pelos componentes 3D X e
Y da coordenada a ser projetada.

Tabela de projecoes (existem 2, uma para X e a outra para Y):
indices nas tabelas: 0 a MAXZ - MINZ (indice para Z = 0 eh o meio)
valores do meio ateh MAXZ sao maiores que 1
valores do meio ateh MINZ sao entre 1 e 0 (o inverso dos valores MAXZ)
Exemplo para projecoes em Y:
seja MINZ = -2000, MAXZ = 2000, CONSTANTE = 1, RESY2 = 100:
indice 2002, Z = 2, projecao = RESY2 / 3 = 33.3333...
indice 2001, Z = 1, projecao = RESY2 / 2 = 50
indice 2000, Z = 0, projecao = RESY2 / 1 = 100
indice 1999, Z = -1, projecao = 1 / RESY2 / 2 = 0.005
indice 1998, Z = -2, projecao = 1 / RESY2 / 3 = 0.003333...

ROTACOES:

Cada coordenada pode ser rotacionada nos planos XY, XZ e YZ.

Rotacoes em ZX:       Rotacoes em XY:      Rotacoes no plano YZ:
  (longe)                 /<-\                   /-\
  /--->--\               /    \                  | |
 |        |--(0 graus)   |    |          (perto) A V (longe)
  \---<--/               \    /                  | |
  (perto)                 \->/(Z nao muda)       \-/

Angulos estao medidos de 0 a NANGS - 1.
*/



#include <string.h>
#include <math.h>

#include "defs.h"

#include "Pol.h"
#include "Pol2d.h"

#include "transf.h"



/* construtor - Calcula tabelas internas
**********************************************************/
CTransf::CTransf ()
{
	// tabela de senos e cossenos
	for ( INT16 ncAng = 0; ncAng < NANGS; ncAng ++ )	{
		m_anSeno [ ncAng ] = (INT) ( sin ( ncAng * Pi / NANGS * 2 ) * 65536 );
		m_anCoss [ ncAng ] = (INT) ( cos ( ncAng * Pi / NANGS * 2 ) * 65536 );
	}

	// calcula tabela de valores para Z projetados em X e Y
   float
      fAfastamentoX = 1,
      fAfastamentoY = 1;
   INT
   	nMeio = ( MAXZ - MINZ ) / 2;
	for ( INT16 ncZ = nMeio; ncZ <= ( nMeio + MAXZ ); ncZ ++ ) {

      // tabela para X
      // valores de 0 a MINZ
		m_afPrjX [ nMeio - ( ncZ - nMeio ) ] = 1 / RESX2 / fAfastamentoX;
      // valores de 0 a MAXZ
		m_afPrjX [ ncZ ] = RESX2 / fAfastamentoX;

      // tabela para Y
      // valores de 0 a MINZ
		m_afPrjY [ nMeio - ( ncZ - nMeio ) ] = 1 / RESY2 / fAfastamentoY;
      // valores de 0 a MAXZ
		m_afPrjY [ ncZ ] = RESY2 / fAfastamentoY;

      fAfastamentoX += 1.6;// determinado pelo angulo de visao em X 320/200*1
      fAfastamentoY += 1;  // determinado pelo angulo de visao em Y
   }
}



/* Rotaciona o poligono conforme 3 angulos (um para cada plano coordenado).
 return poligono 3D rotacionado.
**********************************************************/
CPol& CTransf::mRotaciona ( INT16 nAXY, INT16 nAXZ, INT16 nAYZ, CPol &oPol )
{
	// remove parte dos angulos que nao estah entre a faixa usada
	nAXY &= 255;
	nAYZ &= 255;
	nAXZ &= 255;

	INT16
		nXAux, nYAux, nZAux;

	// faz rotacao de cada vertice do poligono
	for ( INT16 ncV = 0; ncV < 4; ncV ++ ) {

		nXAux              = ( oPol.m_anX [ ncV ] * m_anCoss [ nAXY ] >> 16 ) + ( oPol.m_anY [ ncV ] * m_anSeno [ nAXY ] >> 16 );
		nYAux              = ( oPol.m_anY [ ncV ] * m_anCoss [ nAXY ] >> 16 ) - ( oPol.m_anX [ ncV ] * m_anSeno [ nAXY ] >> 16 );
		oPol.m_anY [ ncV ] = ( nYAux              * m_anCoss [ nAYZ ] >> 16 ) + ( oPol.m_anZ [ ncV ] * m_anSeno [ nAYZ ] >> 16 );
		nZAux              = ( oPol.m_anZ [ ncV ] * m_anCoss [ nAYZ ] >> 16 ) - ( nYAux              * m_anSeno [ nAYZ ] >> 16 );
		oPol.m_anX [ ncV ] = ( nXAux              * m_anCoss [ nAXZ ] >> 16 ) + ( nZAux              * m_anSeno [ nAXZ ] >> 16 );
		oPol.m_anZ [ ncV ] = ( nZAux              * m_anCoss [ nAXZ ] >> 16 ) - ( nXAux              * m_anSeno [ nAXZ ] >> 16 );
   }

	return oPol;
}



/* 1 - Faz translacao em poligono 3D. return poligono
**********************************************************/
CPol& CTransf::mTranslada ( INT16 nTX, INT16 nTY, INT16 nTZ, CPol &oPol )
{
	// altera cada um dos vertices do poligono
	for ( INT16 ncV = 0; ncV < 4; ncV ++ ) {

		oPol.m_anX [ ncV ] += nTX;
		oPol.m_anY [ ncV ] += nTY;
		oPol.m_anZ [ ncV ] += nTZ;
	}

	return oPol;
}



/* 2 - Faz translacao em poligono 2D. return poligono
**********************************************************/
CPol2D& CTransf::mTranslada ( INT16 nTX, INT16 nTY, CPol2D &oPol2D )
{
	// altera cada um dos vertices do poligono
	for ( INT16 ncV = 0; ncV < 4; ncV ++ ) {

		oPol2D.m_anX [ ncV ] += nTX;
		oPol2D.m_anY [ ncV ] += nTY;
	}

	return oPol2D;
}



/* Faz projecao paralela (ignorando Z). return poligono 2D projetado
**********************************************************/
CPol2D& CTransf::mTrunca ( CPol &oPol, CPol2D &oPol2D )
{
	// projeta cada vertice do poligono
	for ( INT16 ncV = 0; ncV < 4; ncV ++ ) {

		oPol2D.m_anX [ ncV ] = oPol.m_anX [ ncV ];
		oPol2D.m_anY [ ncV ] = oPol.m_anY [ ncV ];
	}

	return oPol2D;
}



/* Faz projecao perpectiva (considerando Z). return poligono 2D projetado
**********************************************************/
CPol2D& CTransf::mProjeta ( CPol &oPol, CPol2D &oPol2D )
{
	// projeta cada vertice do poligono
	for ( INT16 ncV = 0; ncV < 4; ncV ++ ) {

		oPol2D.m_anX [ ncV ] = (INT16) ( oPol.m_anX [ ncV ] * m_afPrjX [ oPol.m_anZ [ ncV ] - MINZ ] );
		oPol2D.m_anY [ ncV ] = (INT16) ( oPol.m_anY [ ncV ] * m_afPrjY [ oPol.m_anZ [ ncV ] - MINZ ] );
	}

	return oPol2D;
}
